/*
 * Copyright 2016 frankmuenster.de
 * Lizenziert unter der EUPL, Version 1.1 oder - sobald diese von der
 * Europischen Kommission genehmigt wurden - Folgeversionen der EUPL
 * ("Lizenz"); Sie drfen dieses Werk ausschlielich gem dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 * http://ec.europa.eu/idabc/eupl
 * Sofern nicht durch anwendbare Rechtsvorschriften gefordert oder in
 * schriftlicher Form vereinbart, wird die unter der Lizenz verbreitete Software
 * "so wie sie ist", OHNE JEGLICHE GEWHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrcklich oder stillschweigend - verbreitet. Die sprachspezifischen
 * Genehmigungen und Beschrnkungen unter der Lizenz sind dem Lizenztext zu
 * entnehmen.
 */

package de.frankmuenster.jameica.depot.finanzen.yahoo.finance;

import de.frankmuenster.jameica.depot.finanzen.StockInfoBean;

/**
 * Yahoo Wertpapier Bean
 *
 * @author munstfr
 * @version 1.0
 *
 */
public class YahooStockInfoBean extends StockInfoBean {

	/**
	 * Yahho Symbole
	 */
	private String symbol;

	/**
	 * Standartkonstruktor
	 */
	public YahooStockInfoBean() {
		this(null, null, null, null);
	}

	/**
	 * Konstruktor mit Angabe aller Felder.
	 *
	 * @param symbol
	 *            Das Yahoo-Symbol
	 * @param name
	 *            der Wertpapiername
	 * @param exchange
	 *            Der B&ouml;rsenplatz
	 * @param type
	 *            Der Wertpapiertyp
	 */
	public YahooStockInfoBean(final String symbol, final String name, final String exchange, final String type) {
		super(name, exchange, type, null);
		this.symbol = symbol;
	}

	/**
	 * Liefert das Yahoo-Symbol
	 * 
	 * @return das Yahoo-Symbol
	 */
	public String getSymbol() {
		return this.symbol;
	}

	/**
	 * Setzt das Yahoo-Symbol
	 * 
	 * @param symbol
	 *            das Yahoo-Symbol
	 */
	public void setSymbol(final String symbol) {
		this.symbol = symbol;
	}

	/**
	 * @see Object#toString()
	 */
	@Override
	public String toString() {
		final StringBuffer stringBuffer = new StringBuffer(super.toString());
		if (this.symbol != null) {
			stringBuffer.append(this.symbol);
		}
		return stringBuffer.toString();
	}

}
